#include "PSEmu PlugIn Defs.h"
                            
////////////////////////////////////////////////////////////////////////
// PPDK developer must change libraryName field and can change revision and build
////////////////////////////////////////////////////////////////////////

const  unsigned char version  = 1;    // do not touch - library for PSEmu 1.x
const  unsigned char revision = 1;
const  unsigned char build    = 0;
static char *libraryName      = "XYZ cdr Driver";
static char *PluginAuthor     = "XYZ";

////////////////////////////////////////////////////////////////////////
// stuff to make this a true PDK module
////////////////////////////////////////////////////////////////////////

char * CALLBACK PSEgetLibName(void)
{
 return libraryName;
}

unsigned long CALLBACK PSEgetLibType(void)
{
 return  PSE_LT_CDR;
}

unsigned long CALLBACK PSEgetLibVersion(void)
{
 return version<<16|revision<<8|build;
}

////////////////////////////////////////////////////////////////////////
// Init/shutdown, will be called just once on emu start/close
////////////////////////////////////////////////////////////////////////

long CALLBACK CDRinit(void)
{
 return 0;
}

long CALLBACK CDRshutdown(void)
{
 return 0;
}

////////////////////////////////////////////////////////////////////////
// Open/close should be called when a game starts/stops...
// well, some emus are using the funcs very lazily... if you do
// init/cleanup in the open/close funcs, be sure to add some
// checks in the other funcs as well, if your open has been
// already called
////////////////////////////////////////////////////////////////////////

long CALLBACK CDRopen(void)
{
 return 0;
}

long CALLBACK CDRclose(void)
{
 return 0;
}

////////////////////////////////////////////////////////////////////////
// Gets the first/last tracknumber
////////////////////////////////////////////////////////////////////////

long CALLBACK CDRgetTN(unsigned char *buffer)
{
 if(somethingisbad) return -1;

 buffer[0]=sTOC.cFirstTrack;
 buffer[1]=sTOC.cLastTrack;

 return 0;
}

////////////////////////////////////////////////////////////////////////
// Gets the track start pos in MSF time format
////////////////////////////////////////////////////////////////////////

long CALLBACK CDRgetTD(unsigned char track, unsigned char *buffer)
{
 // if track==0 -> return total length of cd
 // otherwise return start in bcd time format

 buffer[0]=mm;
 buffer[1]=ss;
 buffer[2]=ff;

 return 0;
}

////////////////////////////////////////////////////////////////////////
// Reads data into the internal cdr buffer
// the buffer should be 2340 bytes (without the
// 12 bytes sync data... so the real buffer is
// usually 2352 bytes, but the getBuffer func has
// to return a pointer to the real 2340 sector data)
////////////////////////////////////////////////////////////////////////

long CALLBACK CDRreadTrack(unsigned char *time)
{
 // read one sector at the given time address

 return 0;
}

////////////////////////////////////////////////////////////////////////
// Gets a pointer the last readTrack sector data...
// an emu has to call readTrack first, and gets the
// sector buffer pointer after that, using getBuffer
////////////////////////////////////////////////////////////////////////

unsigned char * CALLBACK CDRgetBuffer(void)
{
 return PointerToLastReadTrackSectorMemory;
}

////////////////////////////////////////////////////////////////////////
// Various dlgs/test funcs
////////////////////////////////////////////////////////////////////////

long CALLBACK CDRconfigure(void)
{
 return 0;
}

void CALLBACK CDRabout(void)
{
}

long CALLBACK CDRtest(void)
{
 return 0;
}

////////////////////////////////////////////////////////////////////////
// CDDA funcs (optionally... only supported by PCSX right now)
////////////////////////////////////////////////////////////////////////

long CALLBACK CDRplay(unsigned char * sector)
{
 // starts playing an audio track at the given time address.
 // Unlike CDRreadTrack the address IS NOT BCD coded!
 
 return 0;
}

long CALLBACK CDRstop(void)
{
 // stops the cdda music... remember to do
 // an additional stop in CDRclose, or music
 // will play on when the main emu quits

 return 0;
}
